#include <stdlib.h>
#include "fxlib.h"
#include "coll_autres.h"
#include "struc.h"




void collisions_ball(Doodle* doodle, Autres* autres)
{
	char heightMobs[] = {38, 29, 12, 19, 17, 16};
	char widthMobs[] = {24, 16, 16, 24, 16, 16};
	if( doodle->ball.x +3 > autres->mob.hauteurReelle +autres->mob.pos
		&& doodle->ball.x < autres->mob.hauteurReelle + autres->mob.pos + widthMobs[autres->mob.type-1]
		&& doodle->ball.y   <= autres->mob.y + heightMobs[autres->mob.type-1]
		&& doodle->ball.y+3 >= autres->mob.y )
	{
		autres->mob.hauteurReelle = 0;
		doodle->ball.active = 0;
	}
}

char collisions_mobs(Doodle* doodle, Autres* autres)
{
	char heightMobs[] = {38, 29, 12, 19, 17, 16};
	char widthMobs[] = {24, 16, 16, 24, 16, 16};


	if(( autres->mob.hauteurReelle+autres->mob.pos  >=  doodle->saut.origine+doodle->saut.hauteur + 12)// trop à droite
	|| (autres->mob.hauteurReelle +autres->mob.pos + widthMobs[autres->mob.type-1]  <= doodle->saut.origine + doodle->saut.hauteur) // trop à gauche
	|| (autres->mob.y   >=   doodle->y + 9) // trop en bas
	|| (autres->mob.y + heightMobs[autres->mob.type-1]  <= doodle->y))// trop en haut
		return 0;
	else if( (doodle->saut.origine + doodle->saut.hauteur) > (autres->mob.hauteurReelle + autres->mob.pos + widthMobs[autres->mob.type-1] -3)
			&& doodle->saut.position >=0)
	{
		doodle->saut.origine = autres->mob.hauteurReelle + autres->mob.pos + widthMobs[autres->mob.type-1] ;
		doodle->saut.position = -51;
		doodle->saut.modeSaut = NORMAL;
		autres->mob.hauteurReelle = 0;
		return 0;
	}
	if(doodle->bouclier)
		return 0;
	if(doodle->saut.position < 0)
		doodle->saut.position = - doodle->saut.position;
	return 1;
}



char collisions_bouclier(Doodle* doodle, Plate* tmp)
{
	int x;
	x = doodle->saut.origine + doodle->saut.hauteur;

	if((tmp->x +4	>= x + 12		)      // trop à droite
	|| (tmp->x +20	<= x			)
	|| (tmp->y -2	>= doodle->y +9	)
	|| (tmp->y +14	<= doodle->y	))
		return 0;
	else
		return 1;
}


