
#include "noob.h"
#include "fonctions.h"
#include "struc.h"
#include "gray.h"
#include "key.h"
#include "syscall.h"



void game_over(int score, int x, int y, int dead, int posCamera, Plate* listePlates)
{
	int cameraOriginal;
	unsigned int temps;
	cameraOriginal = posCamera;
	temps = RTC_GetTicks();

	gray_clearVRAM();

	while(posCamera > cameraOriginal - 200)
	{
		//Sleep(6);
		if(RTC_GetTicks() - temps >= 64 && dead)//si 1/4 de seconde s'est ecouler
		{
			dead ++;
			if(dead == 5)
				dead = 1;
			temps = RTC_GetTicks();
		}
		afficherGameOver(x, y, score, dead, posCamera, listePlates);
		posCamera -= 2 ;
		x -=1;
		if(y<49)// on ramene le doodle a droite
			y ++;
		else if(y>49)// on ramene le doodle a droite
			y --;
	}
	temps = RTC_GetTicks();
	while(x > posCamera)
	{
		if(RTC_GetTicks() - temps >= 64 && dead)//si 1/4 de seconde s'est ecouler
		{
			dead ++;
			if(dead == 5)
				dead = 1;
			temps = RTC_GetTicks();
		}
		//Sleep(6);
		afficherGameOver(x, y, score, dead, posCamera, listePlates);
		x --;
	}
}

static void afficherGameOver(int x, int y, int score, int dead, int posCamera, Plate* listePlates)
{
	int i;
	unsigned char ligne = 126;
	unsigned short centreVRAM1[] = { 15360, 63520, 14384, 63504, 14352, 63504, 14384, 63520, 15360 };
	unsigned short centreVRAM2[] = { 16256, 61408, 12272, 61424, 12272, 61424, 12272, 61408, 16256 };
	unsigned char droiteVRAM1[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 144, 144, 96, 144};
	unsigned char droiteVRAM2[] = {120, 8, 0, 0, 0, 32, 0, 32, 8, 240, 240, 96, 144};
	unsigned char etoiles[3][11] = { {0,2,39,114,32,0,4,78,228,64,0},
	{4,14,4,64,224,66,7,2,32,112,32},
	{16,56,16,2,7,66,224,64,8,28,8} };
	Screen* screen;
	screen = gray_getScreen();
	x -= posCamera;
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM1, x, y, 12, 9, screen->VRAM1);
	ML_bmp_or_cl_buffer((unsigned char*)centreVRAM2, x, y, 12, 9, screen->VRAM2);
	ML_bmp_or_cl_buffer(droiteVRAM1, x+5, y, 5, 13, screen->VRAM1);
	ML_bmp_or_cl_buffer(droiteVRAM2, x+5, y, 5, 13, screen->VRAM2);

	if(dead)
	{
		ML_bmp_or_cl_buffer( etoiles[dead-1], x+12, y, 8, 11, screen->VRAM1);
		ML_bmp_or_cl_buffer( etoiles[dead-1], x+12, y, 8, 11, screen->VRAM2);
	}

	afficher_plateformes(listePlates, posCamera);
	afficher_plateformes(listePlates, posCamera);
	for(i=-1; i<9; i++)// afficher les lignes
	{
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16,  0, 8, 1, screen->VRAM1);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16,  0, 8, 1, screen->VRAM2);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16, 63, 8, 1, screen->VRAM1);
		ML_bmp_or_cl_buffer(&ligne, (posCamera%16) + i*16, 63, 8, 1, screen->VRAM2);
	}
	gray_swapBuffers();
	gray_clearVRAM();
}
