#include <stdlib.h>
#include "fxlib.h"

#include "saves.h"
#include "key.h"

void read_save_keys(unsigned char* keyLeft, unsigned char* keyRight, unsigned char* keyShoot, int tabScores[], unsigned char* contrast)
{
	FONTCHARACTER fileName[] = { '\\', '\\', 'f', 'l', 's', '0', '\\', 'D', 'J', 'U', 'M', 'P', '.', 'd', 'a', 't', 0};//   "\\\\fls0\\DJUMP.dat"
	int handle_file = -1, ok = 0;
	int value = 0;


	handle_file = Bfile_OpenFile( fileName, _OPENMODE_READ);
	if(handle_file >=0)
	{
		Bfile_ReadFile(handle_file, &value, 4, 0);
		ok=1;
	}

	if(  handle_file >=0 && (Bfile_GetFileSize(handle_file)!=48  || value !=20) )//si le fichier existe mais ne respecte pas les normes (la 1ere valeur doir etre = a 19)
	{
		Bfile_CloseFile(handle_file);//on ferme le fichier
		ok=0;
	}
	if(ok)// si le fichier est bon
	{
		Bfile_ReadFile(handle_file, keyLeft, 1, 4 );
		Bfile_ReadFile(handle_file, keyRight, 1, 5 );
		Bfile_ReadFile(handle_file, keyShoot, 1, 6 );
		Bfile_ReadFile(handle_file, contrast, 1, 7 );
		Bfile_ReadFile(handle_file, tabScores, 40, 8 );

		Bfile_CloseFile(handle_file);
	}
	else
		write_save_keys(K_UP, K_DOWN, K_EXE, tabScores, 161);//si erreur dans le fichier ou fichier inexistant, on met les valeurs par defaut

}

void write_save_keys(unsigned char keyLeft, unsigned char keyRight, unsigned char keyShoot, int tabScores[], unsigned char contrast)
{
	FONTCHARACTER fileName[] = { '\\', '\\', 'f', 'l', 's', '0', '\\', 'D', 'J', 'U', 'M', 'P', '.', 'd', 'a', 't', 0};//   "\\\\fls0\\DJUMP.dat"
	int handle_file = -1, i, value = 20;
	unsigned char tab[4] = {0};
	tab[0] = keyLeft;
	tab[1] = keyRight;
	tab[2] = keyShoot;
	tab[3] = contrast;


	Bfile_DeleteFile(fileName);

	if(Bfile_CreateFile(fileName, 48) < 0)/* si impossible de creer un fichier, on quitte*/
		reset_calc();
	handle_file = Bfile_OpenFile(fileName, _OPENMODE_WRITE);
	if(handle_file < 0)// si impossible de l'ouvrir, on quitte aussi
		reset_calc();

	if( Bfile_WriteFile(handle_file, &value, 4 ) <0)
		reset_calc();
	if( Bfile_WriteFile(handle_file, tab, 4 ) <0)
		reset_calc();

	if( Bfile_WriteFile(handle_file, tabScores, 40) <0)
		reset_calc();

	Bfile_CloseFile(handle_file);
}
/*
void maj_records(int* score, int tabScores[])
{
	int i;
	if(*score > tabScores[0])
	{
		for(i=9; i> 0; i--)
			tabScores[i] = tabScores[i-1];
		tabScores[0] = *score;
	}
}
*/
void maj_records(int* score, int tabScores[])
{
	int i, j;

	for(i=0; i<10; i++)
	{
		if(*score > tabScores[i])
		{
			for(j=9; j>i; j--)
				tabScores[j] = tabScores[j-1];
			tabScores[i] = *score;
			break;
		}
	}
}
