#include <stdlib.h>
#include "fxlib.h"
#include "collisions.h"
#include "coll_autres.h"
#include "struc.h"



void collisions_doodle(Doodle* doodle, Plate* listePlates, Autres* autres, char num, char num2)
{
	int x;
	Plate *tmp;

	x = doodle->saut.origine + doodle->saut.hauteur;
	tmp = listePlates;

	if(doodle->dead)
		return;

	if(autres->mob.hauteurReelle && doodle->ball.active)
		collisions_ball(doodle, autres);
	if(autres->mob.hauteurReelle && doodle->saut.modeSaut == NORMAL)
	{
		if( collisions_mobs(doodle, autres) )
			doodle->dead=1;
	}

	if(doodle->saut.position <= 0)/* si on est dans la premiere partie du saut (on monte)*/
		return;
    while(tmp)/* Tant que l'on n'est pas au bout de la liste*/
    {

			if(tmp->ressort == 1)/*collision avec ressort*/
			{
				if ((x == tmp->x +HAUTEUR_PLATEFORME && doodle->y+8 > tmp->y && doodle->y < tmp->y + 4)  )
				{
					doodle->saut.origine = x+1;
					doodle->saut.position = -80;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
				if ((x == tmp->x +HAUTEUR_PLATEFORME-1 && doodle->y+8 > tmp->y && doodle->y < tmp->y + 4)   )
				{
					doodle->saut.origine = x+2;
					doodle->saut.position = -80;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
			}
			else if(tmp->ressort == 2)/*collision avec ressort*/
			{
				if ((x == tmp->x +HAUTEUR_PLATEFORME && doodle->y+1 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME-1) )
				{
					doodle->saut.origine = x+1;
					doodle->saut.position = -80;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
				if ((x == tmp->x +HAUTEUR_PLATEFORME-1 && doodle->y+1 > tmp->y && doodle->y < tmp->y + LARGEUR_PLATEFORME-1) )
				{
					doodle->saut.origine = x+2;
					doodle->saut.position = -80;
					doodle->saut.modeSaut = RESSORT;
					return;
				}
			}
			/*collisions plateformes normales*/
			if( !((tmp->x >= x + 1)
				|| (tmp->x  + 4 <= x)
				|| (tmp->y >= doodle->y + 9)
				|| (tmp->y  + 12 <= doodle->y)) )
			{
				doodle->saut.position = -51;
				doodle->saut.origine = tmp->x + 4;
				doodle->saut.modeSaut = NORMAL ;

				if(tmp->mode == PONCTUELLE)
					tmp->x = -10;
				return;
			}

			if(tmp->mode == JETPACK && x+13 >= tmp->x && x < tmp->x + 7  && doodle->y+5 >= tmp->y  && doodle->y < tmp->y + 11)
			{
				doodle->saut.modeSaut = JET;
				doodle->saut.origine = x+1;
				doodle->saut.position = -300;
				tmp->mode = NORMALE;
			}


        if(tmp->bouclier && collisions_bouclier(doodle, tmp) )
		{
			tmp->bouclier = 0;
			doodle->bouclier = 1;
		}

		tmp = tmp->nxt;
    }
}



