//#include <stdlib.h>

//#include "struc.h"
#include "fonctionsaffich.h"



void afficher_chaine(char* chaine, int x, int y, char* buffer)
{
	unsigned int caractere[2] = {0}, i;

    for(i=0; chaine[i] != '\0'; i++)//for(i=0; i<5; i++)
    {
		switch (chaine[i])
		{
			case 'A': caractere[0] = 0xF8282828 ; caractere[1] = 0xF8000000 ; break ;
			case 'B': caractere[0] = 0xF8A8A8A8 ; caractere[1] = 0x70000000 ; break ;
			case 'C': caractere[0] = 0xF8888888 ; caractere[1] = 0x88000000 ; break ;
			case 'D': caractere[0] = 0xF8888888 ; caractere[1] = 0x70000000 ; break ;
			case 'E': caractere[0] = 0xF8A8A8A8 ; caractere[1] = 0xA8000000 ; break ;
			case 'F': caractere[0] = 0xF8282828 ; caractere[1] = 0x28000000 ; break ;
			case 'G': caractere[0] = 0xF888A8A8 ; caractere[1] = 0xE8000000 ; break ;
			case 'H': caractere[0] = 0xF8202020 ; caractere[1] = 0xF8000000 ; break ;
			case 'I': caractere[0] = 0x8888F888 ; caractere[1] = 0x88000000 ; break ;
			case 'J': caractere[0] = 0x40808888 ; caractere[1] = 0x78000000 ; break ;
			case 'K': caractere[0] = 0xF8202050 ; caractere[1] = 0x88000000 ; break ;
			case 'L': caractere[0] = 0xF8808080 ; caractere[1] = 0x80000000 ; break ;
			case 'M': caractere[0] = 0xF8102010 ; caractere[1] = 0xF8000000 ; break ;
			case 'N': caractere[0] = 0xF8102040 ; caractere[1] = 0xF8000000 ; break ;
			case 'O': caractere[0] = 0xF8888888 ; caractere[1] = 0xF8000000 ; break ;
			case 'P': caractere[0] = 0xF8282828 ; caractere[1] = 0x38000000 ; break ;
			case 'Q': caractere[0] = 0xF88888C8 ; caractere[1] = 0xF8000000 ; break ;
			case 'R': caractere[0] = 0xF82828E8 ; caractere[1] = 0xB8000000 ; break ;
			case 'S': caractere[0] = 0xB8A8A8A8 ; caractere[1] = 0xE8000000 ; break ;
			case 'T': caractere[0] = 0x808F808  ; caractere[1] = 0x8000000  ; break ;
			case 'U': caractere[0] = 0xF8808080 ; caractere[1] = 0xF8000000 ; break ;
			case 'V': caractere[0] = 0x38408040 ; caractere[1] = 0x38000000 ; break ;
			case 'W': caractere[0] = 0x78807880 ; caractere[1] = 0x78000000 ; break ;
			case 'X': caractere[0] = 0x88502050 ; caractere[1] = 0x88000000 ; break ;
			case 'Y': caractere[0] = 0x1820C020 ; caractere[1] = 0x18000000 ; break ;
			case 'Z': caractere[0] = 0x88C8A898 ; caractere[1] = 0x88000000 ; break ;
			case '0': caractere[0] = 0xF88888	; caractere[1] = 0xF8000000 ; break ;
			case '1': caractere[0] = 0x90F880	; caractere[1] = 0x0		; break ;
			case '2': caractere[0] = 0xE8A8A8A8 ; caractere[1] = 0xB8000000 ; break ;
			case '3': caractere[0] = 0x88A8A8A8 ; caractere[1] = 0xF8000000 ; break ;
			case '4': caractere[0] = 0x605048F8 ; caractere[1] = 0x40000000 ; break ;
			case '5': caractere[0] = 0xB8A8A8A8 ; caractere[1] = 0xE8000000 ; break ;
			case '6': caractere[0] = 0xF8A8A8A8 ; caractere[1] = 0xE8000000 ; break ;
			case '7': caractere[0] = 0x808C828  ; caractere[1] = 0x18000000 ; break ;
			case '8': caractere[0] = 0xF8A8A8A8 ; caractere[1] = 0xF8000000 ; break ;
			case '9': caractere[0] = 0xB8A8A8A8 ; caractere[1] = 0xF8000000 ; break ;
			default : caractere[0] = 0x0		; caractere[1] = 0x0		; break ;
		}
		ML_bmp_or_buffer((unsigned char*)caractere, x, y + i*6, 5, 5, buffer);
	}
}

void afficher_nombres_buffer(int numb, int x, int y, char* buffer)//on aurait pu faire int2str puis afficher chaine mais les caracteres sont de tailles différentes
{
	int i, j, l=-1;
	int surface = 0xF888F800;

	if(numb < 0)
		return;
	else if(numb == 0)
	{
		ML_bmp_or_buffer((unsigned char*)&surface, x, y, 5, 3, buffer);
		return;
	}

	for(i=numb ; i ; i/=10)
        l++;
    for(i=numb, j=l; i ; i/=10, j--)
    {
		switch (i%10)
		{
			case 0: surface = 0xF888F800; break ;
			case 1: surface = 0x00F80000; break ;
			case 2: surface = 0xE8A8B800; break ;
			case 3: surface = 0xA8A8F800; break ;
			case 4: surface = 0x7840F800; break ;
			case 5: surface = 0xB8A8E800; break ;
			case 6: surface = 0xF8A8E800; break ;
			case 7: surface = 0x808F800;  break ;
			case 8: surface = 0xF8A8F800; break ;
			case 9: surface = 0xB8A8F800; break ;
			default :					  break;

		}
		ML_bmp_or_buffer((unsigned char*)&surface, x, y+j*4, 5, 3, buffer);
	}

}


