#include <stdlib.h>
#include "fxlib.h"

#include "menu.h"
#include "fonctions.h"
#include "gray.h"
#include "saves.h"
#include "key.h"

#include "fonctionsaffich.h"


void touches(unsigned char* left, unsigned char* right, unsigned char* shoot, int tabScores[], unsigned char contrast)
{
	int posMenu = 1, upLeft = 0, upRight = 0, exeUp = 0, i;
	unsigned char keyNew = 0;
	char chLeft[10] = "", chRight[10] = "", chShoot[10] = "";
	unsigned char gauche[] = { 124, 130, 130, 146, 116, 0, 200, 168, 168, 248, 0, 120, 128, 128, 248, 0, 112,
								136, 136, 80, 0, 254, 8, 8, 240, 0, 112, 168, 168, 176, 0, 0, 0, 0, 0, 136 };
	unsigned char droite[] = { 254, 130, 130, 68, 56, 0, 0, 248, 8, 0, 112, 136, 136, 112, 0, 0, 250, 0, 8, 254, 136, 0, 112, 168, 168, 176, 0, 0, 0, 0, 0, 136 };
	unsigned char tabKeys[] = { 0x61, 0x51, 0x41, 0x31, 0x21, 0x62, 0x52, 0x42, 0x32, 0x22,
								0x63, 0x53, 0x43, 0x33, 0x23, 0x64, 0x54, 0x44, 0x34, 0x00,
								0x65, 0x55, 0x45, 0x35, 0x25, 0x15, 0x66, 0x56, 0x46, 0x36, 0x26, 0x16,
								0x67, 0x57, 0x47, 0x37, /*les 4 touches*/0x28, 0x27, 0x18, 0x17/*fin touches*/, 0x68, 0x58, 0x48, 0x38,
								0x69, 0x59, 0x49, 0x39, 0x29, 0x19 };
	Screen* screen;
	screen = gray_getScreen();

	trouverTouches(*left, chLeft);
	trouverTouches(*right, chRight);
	trouverTouches(*shoot, chShoot);
	while(KeyDown(K_EXE));
	for(posMenu=2; posMenu > -1; posMenu--)
	{
		keyNew =0;
		gray_clearVRAM();
		ML_bmp_or_buffer(gauche, 110, 10, 7, 36, screen->VRAM1);
		ML_bmp_or_buffer(gauche, 110, 10, 7, 36, screen->VRAM2);
		ML_bmp_or_buffer(droite, 80, 10, 7, 32, screen->VRAM1);
		ML_bmp_or_buffer(droite, 80, 10, 7, 32, screen->VRAM2);
		ML_rectangle_buffer(38+posMenu*30, 8, 47+posMenu*30, 48, 1, BLACK, TRANSPARENT, screen->VRAM1);
		ML_rectangle_buffer(38+posMenu*30, 8, 47+posMenu*30, 48, 1, BLACK, TRANSPARENT, screen->VRAM2);
		afficher_chaine(chLeft, 100, 10, screen->VRAM1);
		afficher_chaine(chLeft, 100, 10, screen->VRAM2);
		afficher_chaine(chRight, 70, 10, screen->VRAM1);
		afficher_chaine(chRight, 70, 10, screen->VRAM2);
		afficher_chaine(chShoot, 40, 10, screen->VRAM1);
		afficher_chaine(chShoot, 40, 10, screen->VRAM2);

		gray_swapBuffers();

		while( !keyNew)// tant qu'aucune touche n'est pressee
		{
			for(i=0; i<50; i++)
			{
				if( KeyDown(tabKeys[i]) )// si une touche est activee
				{
					keyNew = tabKeys[i];

					if(keyNew != K_MENU && keyNew != K_EXIT && keyNew != K_F5 && keyNew != K_F6)
					{
						switch(posMenu)
						{
						case 2:
							*left = keyNew;
							trouverTouches(keyNew, chLeft);
							break;
						case 1:
							if(keyNew != *left)
							{
								*right = keyNew;
								trouverTouches(keyNew, chRight);
							}
							else posMenu = 2;
							break;
						case 0:
							if(keyNew != *left && keyNew != *right)
							{
								*shoot = keyNew;
								trouverTouches(keyNew, chShoot);
							}
							else posMenu = 1;
							break;
						default : break;
						}
					}
					while(KeyDown(keyNew));
				}
			}
		}
	}

	gray_clearVRAM();
	ML_bmp_or_buffer(gauche, 110, 10, 7, 36, screen->VRAM1);
	ML_bmp_or_buffer(gauche, 110, 10, 7, 36, screen->VRAM2);
	ML_bmp_or_buffer(droite, 80, 10, 7, 32, screen->VRAM1);
	ML_bmp_or_buffer(droite, 80, 10, 7, 32, screen->VRAM2);
	afficher_chaine(chLeft, 100, 10, screen->VRAM1);
	afficher_chaine(chLeft, 100, 10, screen->VRAM2);
	afficher_chaine(chRight, 70, 10, screen->VRAM1);
	afficher_chaine(chRight, 70, 10, screen->VRAM2);
	afficher_chaine(chShoot, 40, 10, screen->VRAM1);
	afficher_chaine(chShoot, 40, 10, screen->VRAM2);

	gray_swapBuffers();

	/**write_save_keys(*left, *right, *shoot, tabScores, contrast);*/

	Sleep(1200);
	return;
}

void menu_score(int tabScores[])
{
	int i, x=100;
	Screen* screen;
	screen = gray_getScreen();

	gray_clearVRAM();
	afficher_chaine("RECORDS", 120, 14, screen->VRAM1);
	afficher_chaine("RECORDS", 120, 14, screen->VRAM2);
	for(i=1; i<11; i++)
	{
		afficher_nombres_buffer(i, x, 10-(i/10*5), screen->VRAM1);
		afficher_nombres_buffer(i, x, 10-(i/10*5), screen->VRAM2);
		ML_pixel_buffer(x+1, 16, BLACK, screen->VRAM1);
		ML_pixel_buffer(x+1, 16, BLACK, screen->VRAM2);
		ML_pixel_buffer(x+3, 16, BLACK, screen->VRAM1);
		ML_pixel_buffer(x+3, 16, BLACK, screen->VRAM2);
		if(tabScores[i-1]>0)
		{
			afficher_nombres_buffer(tabScores[i-1], x, 22, screen->VRAM1);
			afficher_nombres_buffer(tabScores[i-1], x, 22, screen->VRAM2);
		}
		x -= 8;
	}

	gray_swapBuffers();
	while( KeyDown(K_EXE) );
	while( (!KeyDown(K_EXE)) && (!KeyDown(K_EXIT)) );
	while( KeyDown(K_EXE) || KeyDown(K_EXIT) );

}

int trouverTouches(unsigned char key, char* chaine)
{
	switch (key)
	{
		case K_F1:
			strcpy(chaine, "F1");
			break;
		case K_F2:
			strcpy(chaine, "F2");
			break;
		case K_F3:
			strcpy(chaine, "F3");
			break;
		case K_F4:
			strcpy(chaine, "F4");
			break;
		case K_F5:
			strcpy(chaine, "F5");
			break;
		case K_F6:
			strcpy(chaine, "F6");
			break;

		case K_SHIFT:
			strcpy(chaine, "SHIFT");
			break;
		case K_OPTN:
			strcpy(chaine, "OPTN");
			break;
		case K_VARS:
			strcpy(chaine, "VARS");
			break;
		case K_MENU:
			strcpy(chaine, "MENU");
			break;
		case K_LEFT:
			strcpy(chaine, "LEFT");
			break;
		case K_UP:
			strcpy(chaine, "UP");
			break;

		case K_ALPHA:
			strcpy(chaine, "ALPHA");
			break;
		case K_SQR:
			strcpy(chaine, "SQR");
			break;
		case K_EXPO:
			strcpy(chaine, "EXPO");
			break;
		case K_EXIT:
			strcpy(chaine, "EXIT");
			break;
		case K_DOWN:
			strcpy(chaine, "DOWN");
			break;
		case K_RIGHT:
			strcpy(chaine, "RIGHT");
			break;

		case K_THETA:
			strcpy(chaine, "X");
			break;
		case K_LOG:
			strcpy(chaine, "LOG");
			break;
		case K_LN:
			strcpy(chaine, "LN");
			break;
		case K_SIN:
			strcpy(chaine, "SIN");
			break;
		case K_COS:
			strcpy(chaine, "COS");
			break;
		case K_TAN:
			strcpy(chaine, "TAN");
			break;

		case K_FRAC:
			strcpy(chaine, "FRAC");
			break;
		case K_FD:
			strcpy(chaine, "FD");
			break;
		case K_LPAR:
			strcpy(chaine, "PAR GAUCHE");
			break;
		case K_RPAR:
			strcpy(chaine, "PAR DROITE");
			break;
		case K_COMMA:
			strcpy(chaine, "COMMA");
			break;
		case K_STORE:
			strcpy(chaine, "STORE");
			break;

		case K_0:
			strcpy(chaine, "0");
			break;
		case K_DOT:
			strcpy(chaine, "POINT");
			break;
		case K_EXP:
			strcpy(chaine, "X10");
			break;
		case K_NEG:
			strcpy(chaine, "NEG");
			break;
		case K_EXE:
			strcpy(chaine, "EXE");
			break;

		case K_1:
			strcpy(chaine, "1");
			break;
		case K_2:
			strcpy(chaine, "2");
			break;
		case K_3:
			strcpy(chaine, "3");
			break;
		case K_PLUS:
			strcpy(chaine, "PLUS");
			break;
		case K_MINUS:
			strcpy(chaine, "MOINS");
			break;

		case K_4:
			strcpy(chaine, "4");
			break;
		case K_5:
			strcpy(chaine, "5");
			break;
		case K_6:
			strcpy(chaine, "6");
			break;
		case K_MULT:
			strcpy(chaine, "MULT");
			break;
		case K_DIV:
			strcpy(chaine, "DIV");
			break;

		case K_7:
			strcpy(chaine, "7");
			break;
		case K_8:
			strcpy(chaine, "8");
			break;
		case K_9:
			strcpy(chaine, "9");
			break;
		case K_DEL:
			strcpy(chaine, "DEL");
			break;
		case K_AC:
			strcpy(chaine, "AC");
			break;
		default:
			return 0;
	}
	return 1;
}

